diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
index 4097c59c6..5f3cb63ea 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
@@ -5,6 +5,9 @@ import java.util.function.Supplier;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
@@ -77,6 +80,21 @@ public class BlockLogicDoor extends BlockLogic implements IPaintable
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        if (side.isVertical()) return PartialSupport.INSTANCE;
+        int meta = world.getBlockMetadata(x, y, z);
+        int rot = getRotation(meta);
+        switch (rot) {
+            case 0: return side == Side.NORTH ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+            case 1: return side == Side.EAST ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+            case 2: return side == Side.SOUTH ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+            case 3: return side == Side.WEST ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+
+        }
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
@@ -98,13 +116,13 @@ public class BlockLogicDoor extends BlockLogic implements IPaintable
         }
         float f = 0.1875F;
         switch (rotation) {
-            case 0:
+            case 0: // North
                 return AABB.fromPool(0.0F, bottom, 0.0F, 1.0F, top, f);
-            case 1:
+            case 1: // East
                 return AABB.fromPool(1.0F - f, bottom, 0.0F, 1.0F, top, 1.0F);
-            case 2:
+            case 2: // South
                 return AABB.fromPool(0.0F, bottom, 1.0F - f, 1.0F, top, 1.0F);
-            case 3:
+            case 3: // West
                 return AABB.fromPool(0.0F, bottom, 0.0F, f, top, 1.0F);
             default:
                 return AABB.fromPool(0.0F, bottom, 0.0F, 1.0F, top, 1.0F);
@@ -140,7 +158,16 @@ public class BlockLogicDoor extends BlockLogic implements IPaintable
         {
             world.setBlockMetadataWithNotify(x, y + 1, z, l ^ MASK_OPENED);
         }
-        world.setBlockMetadataWithNotify(x, y, z, l ^ MASK_OPENED);
+        int meta = l ^ MASK_OPENED;
+        world.setBlockMetadataWithNotify(x, y, z, meta);
+        if (!isSupported(world, x, y, z, meta)) {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
+            world.setBlockWithNotify(x, y, z, 0);
+            if(world.getBlockLogic(x, y + 1, z, BlockLogicDoor.class) != null)
+            {
+                world.setBlockWithNotify(x, y + 1, z, 0);
+            }
+        }
         world.markBlocksDirty(x, y - 1, z, x, y, z);
         world.playBlockEvent(player, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
         return true;
@@ -160,7 +187,7 @@ public class BlockLogicDoor extends BlockLogic implements IPaintable
         if(isTop)
         {
             Block<?> b;
-            if((b = Blocks.blocksList[world.getBlockId(x, y - 1, z)]) != null && b.getLogic() instanceof BlockLogicDoor)
+            if((b = world.getBlock(x, y - 1, z)) != null && b.getLogic() instanceof BlockLogicDoor)
             {
             	((BlockLogicDoor)b.getLogic()).onPoweredBlockChange(world, x, y - 1, z, isPowered);
             }
@@ -172,7 +199,7 @@ public class BlockLogicDoor extends BlockLogic implements IPaintable
             return;
         }
         Block<?> b;
-        if((b = Blocks.blocksList[world.getBlockId(x, y + 1, z)]) != null && b.getLogic() instanceof BlockLogicDoor)
+        if((b = world.getBlock(x, y + 1, z)) != null && b.getLogic() instanceof BlockLogicDoor)
         {
             world.setBlockMetadataWithNotify(x, y + 1, z, meta ^ MASK_OPENED);
         }
@@ -184,7 +211,7 @@ public class BlockLogicDoor extends BlockLogic implements IPaintable
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-//        int i1 = world.getBlockMetadata(x, y, z);
+        int metadata = world.getBlockMetadata(x, y, z);
         if(isTop)
         {
         	Block<?> otherBlock = Blocks.blocksList[world.getBlockId(x, y - 1, z)];
@@ -199,16 +226,16 @@ public class BlockLogicDoor extends BlockLogic implements IPaintable
         } else
         {
             boolean flag = false;
-        	Block<?> otherBlock = Blocks.blocksList[world.getBlockId(x, y + 1, z)];
+        	Block<?> otherBlock = world.getBlock(x, y + 1, z);
             if(!(otherBlock != null && otherBlock.getLogic() instanceof BlockLogicDoor))
             {
                 world.setBlockWithNotify(x, y, z, 0);
                 //dropBlockAsItem(world, i, j, k, i1);
                 flag = true;
             }
-            if(!world.canPlaceOnSurfaceOfBlock(x, y - 1, z))
+            if(!isSupported(world, x, y, z, metadata))
             {
-                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, metadata, null, null);
                 world.setBlockWithNotify(x, y, z, 0);
                 flag = true;
                 if(otherBlock != null && otherBlock.getLogic() instanceof BlockLogicDoor)
@@ -216,15 +243,7 @@ public class BlockLogicDoor extends BlockLogic implements IPaintable
                     world.setBlockWithNotify(x, y + 1, z, 0);
                 }
             }
-            if(flag)
-            {
-                if(!world.isClientSide)
-                {
-                    //dropBlockAsItem(world, i, j, k, i1);
-                }
-            } else
-            if(blockId > 0 && Blocks.blocksList[blockId].isSignalSource())
-            {
+            if (!flag && blockId != 0 && Blocks.blocksList[blockId].isSignalSource()) {
                 boolean flag1 = world.hasNeighborSignal(x, y, z) || world.hasNeighborSignal(x, y + 1, z);
                 onPoweredBlockChange(world, x, y, z, flag1);
             }
@@ -302,8 +321,129 @@ public class BlockLogicDoor extends BlockLogic implements IPaintable
             return false;
         } else
         {
-            return world.canPlaceOnSurfaceOfBlock(x, y - 1, z) && super.canPlaceBlockAt(world, x, y, z) && super.canPlaceBlockAt(world, x, y + 1, z);
+            return isSupported(world, x, y, z, world.getBlockMetadata(x, y, z)) && super.canPlaceBlockAt(world, x, y + 1, z);
+        }
+    }
+
+    public boolean canPlaceBlockAt(@NotNull World world, int x, int y, int z, int metadata) {
+        if(y >= world.getHeightBlocks() - 1)
+        {
+            return false;
+        } else
+        {
+            return isSupported(world, x, y, z, metadata) && super.canPlaceBlockAt(world, x, y + 1, z);
+        }
+    }
+
+    public boolean isSupported(@NotNull World world, int x, int y, int z, int meta) {
+        if (isTop) return true;
+        ISupport sBelow = world.getSupport(x, y - 1, z, Side.TOP);
+        boolean opened = (meta & MASK_OPENED) != 0;
+        boolean hinge = (meta & MASK_HINGE) != 0;
+//        world.sendGlobalMessage(String.format("Rot: %s, Opened: %s, Hinge: %s", getRotation(meta), opened, hinge));
+        Side side;
+        ISupport hingeSupport;
+        if (opened) {
+            if (hinge) {
+                switch (getRotation(meta)) {
+                    case 0: {
+                        side = Side.WEST;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
+                    }
+                    case 1: {
+                        side = Side.NORTH;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
+                    }
+                    case 2: {
+                        side = Side.EAST;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
+                    }
+                    case 3: {
+                        side = Side.SOUTH;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
+                    }
+
+                }
+            } else {
+                switch (getRotation(meta)) {
+                    case 0: {
+                        side = Side.NORTH;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
+                    }
+                    case 1: {
+                        side = Side.EAST;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
+                    }
+                    case 2: {
+                        side = Side.SOUTH;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
+                    }
+                    case 3: {
+                        side = Side.WEST;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
+                    }
+                }
+            }
+        } else {
+            if (hinge) {
+                switch (getRotation(meta)) {
+                    case 0: {
+                        side = Side.NORTH;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
+                    }
+                    case 1: {
+                        side = Side.EAST;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
+                    }
+                    case 2: {
+                        side = Side.SOUTH;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
+                    }
+                    case 3: {
+                        side = Side.WEST;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
+                    }
+
+                }
+            } else {
+                switch (getRotation(meta)) {
+                    case 0: {
+                        side = Side.EAST;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
+                    }
+                    case 1: {
+                        side = Side.SOUTH;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
+                    }
+                    case 2: {
+                        side = Side.WEST;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
+                    }
+                    case 3: {
+                        side = Side.NORTH;
+                        hingeSupport = world.getSupport(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ(), side.getOpposite());
+                        return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
+                    }
+
+                }
+            }
         }
+        return false;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
index 7c58044e1..cb4b06215 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEdible.java
@@ -2,6 +2,8 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
@@ -47,6 +49,11 @@ public abstract class BlockLogicEdible extends BlockLogic {
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     private void eatSlice(World world, int x, int y, int z, Player entityplayer)
     {
         if(entityplayer.getHealth() < entityplayer.getMaxHealth())
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
index da3ebee64..79a3a57d1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
@@ -2,12 +2,14 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.HumanArmorShape;
-import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -15,6 +17,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
@@ -119,6 +122,11 @@ public class BlockLogicFarmland extends BlockLogic implements IBonemealable
 		return false;
 	}
 
+	@Override
+	public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+		return side == Side.TOP ? PartialSupport.INSTANCE : FullSupport.INSTANCE;
+	}
+
 	private boolean isWaterNearby(final World world, final int x, final int y, final int z, int range)
 	{
 		for (int x1 = x - range; x1 <= x + range; x1++)
@@ -216,7 +224,7 @@ public class BlockLogicFarmland extends BlockLogic implements IBonemealable
 	}
 
 	@Override
-	public void updateTick(final World world, final int x, final int y, final int z, final Random rand) {
+	public void updateTick(final World world, final int x, final int y, final int z, final Random rand, boolean isRandomTick) {
 		if (rand.nextInt(2) != 0) {
 			world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay() - rand.nextInt(10) + rand.nextInt(10));
 			return;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
index 356cffe02..953c0934a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
@@ -1,11 +1,15 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 
@@ -66,6 +70,11 @@ public class BlockLogicFence extends BlockLogic implements IPaintable
         return true;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return side.isVertical() ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
+    }
+
     @Override
     public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
index 4159c16f1..51607e684 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
@@ -2,6 +2,8 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
@@ -73,6 +75,11 @@ public class BlockLogicFenceGate extends BlockLogic implements IPaintable
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
     	int direction = mob.getHorizontalPlacementDirection(side).getHorizontalIndex();
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
index 1240372f5..3d8797bfb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
@@ -1,9 +1,14 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class BlockLogicFenceThin extends BlockLogic
 {
@@ -18,6 +23,11 @@ public abstract class BlockLogicFenceThin extends BlockLogic
         return true;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return side.isVertical() ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
+    }
+
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
index cd6f60d66..1ce810e61 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
@@ -1,9 +1,12 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
@@ -11,6 +14,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.weather.IPrecipitation;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -96,6 +100,11 @@ public class BlockLogicFire extends BlockLogic {
 		return false;
 	}
 
+	@Override
+	public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+		return PartialSupport.INSTANCE;
+	}
+
 	@Override
 	public void onBlockRemoved(World world, int x, int y, int z, int data)
 	{
@@ -115,7 +124,7 @@ public class BlockLogicFire extends BlockLogic {
 	}
 
 	@Override
-	public void updateTick(World world, int x, int y, int z, Random rand) {
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
 		Block<?> blockUnder = world.getBlock(x, y - 1, z);
 		boolean infiniBurn = blockUnder != null && blockUnder.hasTag(BlockTags.INFINITE_BURN);
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
index acd8067e1..886a7ebe9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
@@ -13,7 +13,7 @@ public class BlockLogicFireCold extends BlockLogicFire {
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand) {
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
         Block blockUnder = world.getBlock(x, y - 1, z);
         boolean infiniBurn = blockUnder != null && blockUnder.hasTag(BlockTags.INFINITE_BURN_COLD) || !world.getGameRuleValue(GameRules.DO_FIRE_SPREAD);
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
index 1772a1c40..8333c46ed 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
@@ -3,6 +3,8 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
@@ -13,6 +15,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicFlag extends BlockLogic {
 
@@ -41,6 +44,11 @@ public class BlockLogicFlag extends BlockLogic {
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
index 5b66dce3f..b87eb842e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.player.Player;
@@ -11,6 +13,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
@@ -48,6 +51,11 @@ public class BlockLogicFlower extends BlockLogic implements IBonemealable {
         return super.canPlaceBlockAt(world, x, y, z) && mayPlaceOn(world.getBlockId(x, y - 1, z));
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     protected boolean mayPlaceOn(int blockId) {
         if (Blocks.blocksList[blockId] == null) return false;
         return Blocks.blocksList[blockId].hasTag(BlockTags.GROWS_FLOWERS);
@@ -60,7 +68,7 @@ public class BlockLogicFlower extends BlockLogic implements IBonemealable {
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand) {
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
         checkAlive(world, x, y, z);
 
         if (world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getSeasonManager().getCurrentSeason() != null && (!isPermanent(world.getBlockMetadata(x, y, z))) && world.getSeasonManager().getCurrentSeason().killFlowers && killedByWeather && rand.nextInt(256) == 0) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index cfa2bdd28..4fc185c15 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -2,6 +2,8 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -62,6 +64,11 @@ public abstract class BlockLogicFluid extends BlockLogic {
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public boolean canCollideCheck(final int meta, final boolean shouldCollideWithFluids) {
         return shouldCollideWithFluids && (meta & 0x0F) == 0;
